#include <stdio.h>

#include "gdew0213m21_epd.h"
#include "des_epd_impl.h"

des_epd_t g_epd = {
    .cb = {
        .reset_cb = _des_epd_reset,
        .poll_busy_cb = _des_epd_poll_busy,
        .write_cmd_cb = _des_epd_write_cmd,
        .write_data_cb = _des_epd_write_data
    },
    .user_data = NULL
};

int main() {
    printf("Starting EPD example app!\n");

    g_epd.user_data = _des_epd_impl_init();
    if(g_epd.user_data == NULL) return -1;

    des_epd_ret_t ret = des_epd_init(&g_epd, 0);
    if(ret == DES_EPD_OK) {
        printf("EPD init OK!\n");
    }

    _des_epd_impl_deinit(g_epd.user_data);
    return 0;
}